-- Do not manually edit this file, it was auto-generated by dillonkearns/elm-graphql
-- https://github.com/dillonkearns/elm-graphql


module Shared.Api.Schema.Query exposing (me, selection)

import Graphql.Field as Field exposing (Field)
import Graphql.Internal.Builder.Argument as Argument exposing (Argument)
import Graphql.Internal.Builder.Object as Object
import Graphql.Internal.Encode as Encode exposing (Value)
import Graphql.Operation exposing (RootMutation, RootQuery, RootSubscription)
import Graphql.OptionalArgument exposing (OptionalArgument(..))
import Graphql.SelectionSet exposing (SelectionSet)
import Json.Decode as Decode exposing (Decoder)
import Shared.Api.Schema.InputObject
import Shared.Api.Schema.Interface
import Shared.Api.Schema.Object
import Shared.Api.Schema.Scalar
import Shared.Api.Schema.Union


{-| Select fields to build up a top-level query. The request can be sent with
functions from `Graphql.Http`.
-}
selection : (a -> constructor) -> SelectionSet (a -> constructor) RootQuery
selection constructor =
    Object.selection constructor


{-| Get the user account of the currently logged in user.
-}
me : SelectionSet decodesTo Shared.Api.Schema.Object.User -> Field decodesTo RootQuery
me object_ =
    Object.selectionField "me" [] object_ identity
